package mediafeeds;

import java.awt.*;
import java.awt.event.*;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Platform;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.collections.ObservableList;
import static javafx.concurrent.Worker.State.FAILED;
import javafx.embed.swing.JFXPanel;
import javafx.event.EventDispatcher;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.web.WebEngine;
import javafx.scene.web.WebEvent;
import javafx.scene.web.WebHistory;
import javafx.scene.web.WebView;
import javax.swing.*;

public class MediaFeeds extends JFrame {

    static Point mouseDownCompCoords;
    private final JFXPanel jfxPanel = new JFXPanel();
    private WebEngine engine;

    private final JPanel panel = new JPanel(new BorderLayout());
    private final JLabel lblStatus = new JLabel();
    ImageIcon e = new ImageIcon("data/Icons/exit.png");
    ImageIcon p = new ImageIcon("data/Icons/plus.png");
    ImageIcon m = new ImageIcon("data/Icons/minus.png");
    ImageIcon b = new ImageIcon("data/Icons/back.png");
    private final JButton exit = new JButton(e);
    private final JButton newFeed = new JButton(p);
    private final JButton remove = new JButton(m);
    private final JButton backward = new JButton(b);
    private final JButton forward = new JButton(">");
    private final JTextArea oldURL = new JTextArea(10, 10);
    private final JTextArea toGo = new JTextArea(10, 10);
    private final JButton btnGo = new JButton("Go");
    private final JTextField txtURL = new JTextField();
    private final JProgressBar progressBar = new JProgressBar();

    public MediaFeeds() throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {
        super();
        initComponents();
    }

    private void initComponents() throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {
        createScene();

        ActionListener al = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                loadURL(txtURL.getText());
            }
        };

        ActionListener exitListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        };
        ActionListener removeListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                try {
                    String rFeed = JOptionPane.showInputDialog("Enter name of feed\nyou would like to remove");
                    Scanner user_input = new Scanner(System.in);
                    String all = new Scanner(new File("feeds.html")).useDelimiter("\\A").next();
                    int length = rFeed.length();
                    String outF = null;
                    if (length <= 12) {
                        String temp = "</br><center><a href=\"http://www.facebook.com/plugins/likebox.php?href=https%3A%2F%2Fwww.facebook.com%2F" + rFeed + "&width=300&height=500&colorscheme=light&show_faces=false&header=false&stream=true&show_border=true\" title=\"Feeds for " + rFeed + "\" class=\"fbutton\">" + rFeed + "</a>\n</p>";
                        outF = all.replace(temp, "");
                    }
                    if (length > 12) {
                        String shortFeed = rFeed.substring(0, Math.min(length, 9)) + "...";
                        String temp = "</br><center><a href=\"http://www.facebook.com/plugins/likebox.php?href=https%3A%2F%2Fwww.facebook.com%2F" + rFeed + "&width=300&height=500&colorscheme=light&show_faces=false&header=false&stream=true&show_border=true\" title=\"Feeds for " + rFeed + "\" class=\"fbutton\">" + shortFeed + "</a>\n</p>";
                        outF = all.replace(temp, "");
                    }
                    FileWriter outFile = new FileWriter("feeds.html");
                    BufferedWriter outStream = new BufferedWriter(outFile);
                    outStream.write(outF);
                    outStream.newLine();
                    outStream.close();
                    String wd = System.getProperty("user.dir");
                    wd = wd.replace("\\", "/");
                    wd = wd.replace(" ", "%20");
                    String toFeed = "file:///" + wd + "/feeds.html";
                    loadURL(toFeed);
                } catch (Exception kill) {
                    System.out.println("");
                }
            }
        };
        ActionListener feedListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                int confirm2 = JOptionPane.showOptionDialog(null, "Do you know the facebook page by heart?\n"
                        + "'YES' to manually type it or 'NO' to search", "?", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
                if (confirm2 == 0) {
                    String fFeed = JOptionPane.showInputDialog("Add facebook feed");
                    int length = fFeed.length();
                    String outF = null;
                    if (length <= 12) {
                        outF = "</br><center><a href=\"http://www.facebook.com/plugins/likebox.php?href=https%3A%2F%2Fwww.facebook.com%2F" + fFeed + "&width=300&height=500&colorscheme=light&show_faces=false&header=false&stream=true&show_border=true\" title=\"Feeds for " + fFeed + "\" class=\"fbutton\">" + fFeed + "</a>\n</p>";
                    }
                    if (length > 12) {
                        String shortFeed = fFeed.substring(0, Math.min(length, 9)) + "...";
                        outF = "</br><center><a href=\"http://www.facebook.com/plugins/likebox.php?href=https%3A%2F%2Fwww.facebook.com%2F" + fFeed + "&width=300&height=500&colorscheme=light&show_faces=false&header=false&stream=true&show_border=true\" title=\"Feeds for " + fFeed + "\" class=\"fbutton\">" + shortFeed + "</a>\n</p>";
                    }
                    try {
                        FileWriter outFile = new FileWriter("feeds.html", true);
                        BufferedWriter outStream = new BufferedWriter(outFile);
                        outStream.write(outF);
                        outStream.newLine();
                        outStream.close();
                    } catch (Exception butt) {
                        System.out.println("");
                    }
                    String wd = System.getProperty("user.dir");
                    wd = wd.replace("\\", "/");
                    wd = wd.replace(" ", "%20");
                    String toFeed = "file:///" + wd + "/feeds.html";
                    JOptionPane.showMessageDialog(null, "Added feed");
                    loadURL(toFeed);
                }
                if (confirm2 == 1) {
                     try {
                        Runtime.getRuntime().exec("java -jar MediaFeedsFacebookFinder.jar");
                    } catch (Exception ex2) {
                        System.out.println("Do nothing");
                    }
                }
            }
        };
        ActionListener forwardListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                loadURL(goForward());
            }
        };
        ActionListener backwardListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                loadURL(goBack());
            }
        };
        newFeed.addMouseListener(new MouseAdapter() {
            public void mouseEntered(MouseEvent evt) {
                ImageIcon pp = new ImageIcon("data/Icons/plus-hover.png");
                newFeed.setIcon(pp);
            }

            public void mouseExited(MouseEvent evt) {
                ImageIcon ppp = new ImageIcon("data/Icons/plus.png");
                newFeed.setIcon(ppp);
            }
        });
        remove.addMouseListener(new MouseAdapter() {
            public void mouseEntered(MouseEvent evt) {
                ImageIcon pp = new ImageIcon("data/Icons/minus-hover.png");
                remove.setIcon(pp);
            }

            public void mouseExited(MouseEvent evt) {
                ImageIcon ppp = new ImageIcon("data/Icons/minus.png");
                remove.setIcon(ppp);
            }
        });
        backward.addMouseListener(new MouseAdapter() {
            public void mouseEntered(MouseEvent evt) {
                ImageIcon pp = new ImageIcon("data/Icons/back-hover.png");
                backward.setIcon(pp);
            }

            public void mouseExited(MouseEvent evt) {
                ImageIcon ppp = new ImageIcon("data/Icons/back.png");
                backward.setIcon(ppp);
            }
        });
        exit.addMouseListener(new MouseAdapter() {
            public void mouseEntered(MouseEvent evt) {
                ImageIcon pp = new ImageIcon("data/Icons/exit-hover.png");
                exit.setIcon(pp);
            }

            public void mouseExited(MouseEvent evt) {
                ImageIcon ppp = new ImageIcon("data/Icons/exit.png");
                exit.setIcon(ppp);
            }
        });
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        btnGo.addActionListener(al);
        txtURL.addActionListener(al);

        progressBar.setPreferredSize(new Dimension(150, 18));
        progressBar.setStringPainted(true);

        JPanel topBar = new JPanel(new BorderLayout());
        GridLayout griddy = new GridLayout(0, 4);
        topBar.setLayout(griddy);
        topBar.setBorder(BorderFactory.createEmptyBorder(3, 5, 3, 5));
        topBar.add(backward);
        topBar.add(newFeed);
        topBar.add(remove);
        topBar.add(exit);
        exit.addActionListener(exitListener);
        newFeed.addActionListener(feedListener);
        forward.addActionListener(forwardListener);
        backward.addActionListener(backwardListener);
        remove.addActionListener(removeListener);
        exit.setToolTipText("Exit program");
        newFeed.setToolTipText("Add new feed");
        remove.setToolTipText("Remove a feed");
        backward.setToolTipText("Go to previous page");
        exit.setBorderPainted(false);
        newFeed.setBorderPainted(false);
        remove.setBorderPainted(false);
        backward.setBorderPainted(false);
        JPanel statusBar = new JPanel(new BorderLayout(5, 0));
        statusBar.setBorder(BorderFactory.createEmptyBorder(3, 5, 3, 5));
        statusBar.add(lblStatus, BorderLayout.CENTER);
        statusBar.add(progressBar, BorderLayout.EAST);
        toGo.setText("0");

        panel.add(topBar, BorderLayout.NORTH);
        panel.add(jfxPanel, BorderLayout.CENTER);
        // panel.add(statusBar, BorderLayout.SOUTH);

        getContentPane().add(panel);
        //setIconImage(Toolkit.getDefaultToolkit().getImage("data/images/bluebert.png"));
        setPreferredSize(new Dimension(300, 310));
        Toolkit tk = Toolkit.getDefaultToolkit();
        int xSize = ((int) tk.getScreenSize().getWidth());
        setLocation(xSize - 300, 0);
        setResizable(false);
        setUndecorated(true);
        addComponentListener(new SystemInfoAppImpl());
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        mouseDownCompCoords = null;
        topBar.addMouseListener(new MouseListener() {
            public void mouseReleased(MouseEvent e) {
                mouseDownCompCoords = null;
            }

            public void mousePressed(MouseEvent e) {
                mouseDownCompCoords = e.getPoint();
            }

            public void mouseExited(MouseEvent e) {
            }

            public void mouseEntered(MouseEvent e) {
            }

            public void mouseClicked(MouseEvent e) {
            }
        });
        topBar.addMouseMotionListener(new MouseMotionListener() {
            public void mouseMoved(MouseEvent e) {
            }

            public void mouseDragged(MouseEvent e) {
                Point currCoords = e.getLocationOnScreen();
                setLocation(currCoords.x - mouseDownCompCoords.x, currCoords.y - mouseDownCompCoords.y);
            }
        });
        pack();

    }

    public String goBack() {
        /*  final WebHistory history = engine.getHistory();
         ObservableList<WebHistory.Entry> entryList = history.getEntries();
         int currentIndex = history.getCurrentIndex();
         Platform.runLater(new Runnable() {
         public void run() {
         history.go(-1);
         }
         });
         return entryList.get(currentIndex > 0 ? currentIndex - 1 : currentIndex).getUrl();*/
        String wd = System.getProperty("user.dir");
        wd = wd.replace("\\", "/");
        wd = wd.replace(" ", "%20");
        String toFeed = "file:///" + wd + "/feeds.html";
        return toFeed;
    }

    public String goForward() {
        final WebHistory history = engine.getHistory();
        ObservableList<WebHistory.Entry> entryList = history.getEntries();
        int currentIndex = history.getCurrentIndex();
        Platform.runLater(new Runnable() {
            public void run() {
                history.go(1);
            }
        });
        return entryList.get(currentIndex < entryList.size() - 1 ? currentIndex + 1 : currentIndex).getUrl();
    }

    private void createScene() {

        Platform.runLater(new Runnable() {
            @Override
            public void run() {

                WebView view = new WebView();
                EventDispatcher originalDispatcher = view.getEventDispatcher();
                view.setEventDispatcher((EventDispatcher) new stopClick(originalDispatcher));
                engine = view.getEngine();

                engine.titleProperty().addListener(new ChangeListener<String>() {
                    @Override
                    public void changed(ObservableValue<? extends String> observable, String oldValue, final String newValue) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override
                            public void run() {
                                MediaFeeds.this.setTitle(newValue);
                            }
                        });
                    }
                });

                engine.setOnStatusChanged(new EventHandler<WebEvent<String>>() {
                    @Override
                    public void handle(final WebEvent<String> event) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override
                            public void run() {
                                lblStatus.setText(event.getData());
                            }
                        });
                    }
                });

                engine.locationProperty().addListener(new ChangeListener<String>() {
                    @Override
                    public void changed(ObservableValue<? extends String> ov, String oldValue, final String newValue) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override
                            public void run() {
                                /* int y = Integer.parseInt(toGo.getText());
                                 if (newValue.contains("http://www.facebook.com/plugins/likebox.php?href=https%3A%2F%2Fwww.facebook.com%2F") || newValue.contains("file:///")) {
                                 toGo.setText("1");
                                 oldURL.setText(newValue);
                                 } else {
                                 toGo.setText("0");
                                 Desktop d = Desktop.getDesktop();
                                 try {
                                 d.browse(new URI(newValue));
                                 } catch (IOException ex) {
                                 System.out.println("An IO Exception has occured");
                                 } catch (URISyntaxException ex) {
                                 System.out.println("Site URL incorrect");
                                 }
                                 loadURL(oldURL.getText());
                                 }*/
                                if (newValue.contains("file:///")) {
                                    backward.setEnabled(false);
                                } else {
                                    backward.setEnabled(true);
                                }
                            }
                        });
                    }
                });

                engine.getLoadWorker().workDoneProperty().addListener(new ChangeListener<Number>() {
                    @Override
                    public void changed(ObservableValue<? extends Number> observableValue, Number oldValue, final Number newValue) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override
                            public void run() {
                                progressBar.setValue(newValue.intValue());
                            }
                        });
                    }
                });

                engine.getLoadWorker()
                        .exceptionProperty()
                        .addListener(new ChangeListener<Throwable>() {

                            public void changed(ObservableValue<? extends Throwable> o, Throwable old, final Throwable value) {
                                if (engine.getLoadWorker().getState() == FAILED) {
                                    SwingUtilities.invokeLater(new Runnable() {
                                        @Override
                                        public void run() {
                                            JOptionPane.showMessageDialog(
                                                    panel,
                                                    (value != null)
                                                    ? engine.getLocation() + "\n" + value.getMessage()
                                                    : engine.getLocation() + "\nUnexpected error.",
                                                    "Loading error...",
                                                    JOptionPane.ERROR_MESSAGE);
                                        }
                                    });
                                }
                            }
                        });

                jfxPanel.setScene(new Scene(view));
            }
        });
    }

    public void loadURL(final String url) {
        Platform.runLater(new Runnable() {
            @Override
            public void run() {
                String tmp = toURL(url);

                if (tmp == null) {
                    tmp = toURL("http://" + url);
                }

                engine.load(tmp);
            }
        });
    }

    private static String toURL(String str) {
        try {
            return new URL(str).toExternalForm();
        } catch (MalformedURLException exception) {
            return null;
        }
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                MediaFeeds browser = null;
                try {
                    browser = new MediaFeeds();
                } catch (ClassNotFoundException ex) {
                    Logger.getLogger(MediaFeeds.class.getName()).log(Level.SEVERE, null, ex);
                } catch (InstantiationException ex) {
                    Logger.getLogger(MediaFeeds.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalAccessException ex) {
                    Logger.getLogger(MediaFeeds.class.getName()).log(Level.SEVERE, null, ex);
                } catch (UnsupportedLookAndFeelException ex) {
                    Logger.getLogger(MediaFeeds.class.getName()).log(Level.SEVERE, null, ex);
                }
                browser.setVisible(true);
                String wd = System.getProperty("user.dir");
                wd = wd.replace("\\", "/");
                wd = wd.replace(" ", "%20");
                String toFeed = "file:///" + wd + "/feeds.html";
                browser.loadURL(toFeed);
            }
        });
    }
}
