package mediafeedsfacebookfinder;

import java.awt.*;
import java.awt.event.*;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Platform;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import static javafx.concurrent.Worker.State.FAILED;
import javafx.embed.swing.JFXPanel;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.web.WebEngine;
import javafx.scene.web.WebEvent;
import javafx.scene.web.WebView;
import javax.swing.*;
import static org.hullabaloo.basic.core.hcore.getScreenHeight;
import static org.hullabaloo.basic.core.hcore.getScreenWidth;

public class MediaFeedsFacebookFinder extends JFrame {

    private final JFXPanel jfxPanel = new JFXPanel();
    private WebEngine engine;

    private final JPanel panel = new JPanel(new BorderLayout());
    private final JLabel lblStatus = new JLabel();

    ImageIcon p = new ImageIcon("data/Icons/plus.png");
    private final JButton btnGo = new JButton("Go");
    private final JButton getURL = new JButton(p);
    private final JTextField txtURL = new JTextField();
    private final JProgressBar progressBar = new JProgressBar();

    public MediaFeedsFacebookFinder() throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {
        super();
        initComponents();
    }

    private void initComponents() throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {
        createScene();

        ActionListener al = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                loadURL(txtURL.getText());
            }
        };
        ActionListener feedListener = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String fFeed = txtURL.getText();
                if (fFeed.contains("https://www.facebook.com/srch.php")) {
                } else {
                    String fFeed2 = fFeed.replace("https://www.facebook.com/", "");
                    int confirm2 = JOptionPane.showOptionDialog(null, "Add " + fFeed2 + " to you feeds?", "?", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
                    if (confirm2 == 0) {
                        int length = fFeed2.length();
                        String outF = null;
                        if (length <= 12) {
                            outF = "</br><center><a href=\"http://www.facebook.com/plugins/likebox.php?href=https%3A%2F%2Fwww.facebook.com%2F" + fFeed2 + "&width=300&height=500&colorscheme=light&show_faces=false&header=false&stream=true&show_border=true\" title=\"Feeds for " + fFeed2 + "\" class=\"fbutton\">" + fFeed2 + "</a>\n</p>";
                        }
                        if (length > 12) {
                            String shortFeed = fFeed2.substring(0, Math.min(length, 9)) + "...";
                            outF = "</br><center><a href=\"http://www.facebook.com/plugins/likebox.php?href=https%3A%2F%2Fwww.facebook.com%2F" + fFeed2 + "&width=300&height=500&colorscheme=light&show_faces=false&header=false&stream=true&show_border=true\" title=\"Feeds for " + fFeed2 + "\" class=\"fbutton\">" + shortFeed + "</a>\n</p>";
                        }
                        try {
                            FileWriter outFile = new FileWriter("feeds.html", true);
                            BufferedWriter outStream = new BufferedWriter(outFile);
                            outStream.write(outF);
                            outStream.newLine();
                            outStream.close();
                        } catch (Exception butt) {
                            System.out.println("");
                        }
                        String wd = System.getProperty("user.dir");
                        wd = wd.replace("\\", "/");
                        wd = wd.replace(" ", "%20");
                        String toFeed = "file:///" + wd + "/feeds.html";
                        JOptionPane.showMessageDialog(null, "Added feed");
                        loadURL("https://www.facebook.com/srch.php");
                    }
                }
            }
        };
        getURL.addMouseListener(new MouseAdapter() {
            public void mouseEntered(MouseEvent evt) {
                ImageIcon pp = new ImageIcon("data/Icons/plus-hover.png");
                getURL.setIcon(pp);
            }

            public void mouseExited(MouseEvent evt) {
                ImageIcon ppp = new ImageIcon("data/Icons/plus.png");
                getURL.setIcon(ppp);
            }
        });
        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());

        JPanel topBar = new JPanel(new BorderLayout(0, 1));
        topBar.setBorder(BorderFactory.createEmptyBorder(3, 5, 3, 5));
        topBar.add(getURL, BorderLayout.EAST);
        getURL.addActionListener(feedListener);
        panel.add(topBar, BorderLayout.NORTH);
        panel.add(jfxPanel, BorderLayout.CENTER);

        getContentPane().add(panel);
        //setIconImage(Toolkit.getDefaultToolkit().getImage("data/images/bluebert.png"));
        setPreferredSize(new Dimension(getScreenWidth(), getScreenHeight() - 40));
        setMinimumSize(new Dimension(getScreenWidth() / 2, getScreenHeight() / 2));
        setPreferredSize(new Dimension(400, 600));
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle("Add feeds");
        pack();

    }

    private void createScene() {

        Platform.runLater(new Runnable() {
            @Override
            public void run() {

                WebView view = new WebView();
                engine = view.getEngine();

                engine.titleProperty().addListener(new ChangeListener<String>() {
                    @Override
                    public void changed(ObservableValue<? extends String> observable, String oldValue, final String newValue) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override
                            public void run() {
                                //MediaFeedsFacebookFinder.this.setTitle(newValue);
                            }
                        });
                    }
                });

                engine.setOnStatusChanged(new EventHandler<WebEvent<String>>() {
                    @Override
                    public void handle(final WebEvent<String> event) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override
                            public void run() {
                                lblStatus.setText(event.getData());
                            }
                        });
                    }
                });

                engine.locationProperty().addListener(new ChangeListener<String>() {
                    @Override
                    public void changed(ObservableValue<? extends String> ov, String oldValue, final String newValue) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override
                            public void run() {
                                txtURL.setText(newValue);
                            }
                        });
                    }
                });

                engine.getLoadWorker().workDoneProperty().addListener(new ChangeListener<Number>() {
                    @Override
                    public void changed(ObservableValue<? extends Number> observableValue, Number oldValue, final Number newValue) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override
                            public void run() {
                                progressBar.setValue(newValue.intValue());
                            }
                        });
                    }
                });

                engine.getLoadWorker()
                        .exceptionProperty()
                        .addListener(new ChangeListener<Throwable>() {

                            public void changed(ObservableValue<? extends Throwable> o, Throwable old, final Throwable value) {
                                if (engine.getLoadWorker().getState() == FAILED) {
                                    SwingUtilities.invokeLater(new Runnable() {
                                        @Override
                                        public void run() {
                                            JOptionPane.showMessageDialog(
                                                    panel,
                                                    (value != null)
                                                    ? engine.getLocation() + "\n" + value.getMessage()
                                                    : engine.getLocation() + "\nUnexpected error.",
                                                    "Loading error...",
                                                    JOptionPane.ERROR_MESSAGE);
                                        }
                                    });
                                }
                            }
                        });

                jfxPanel.setScene(new Scene(view));
            }
        });
    }

    public void loadURL(final String url) {
        Platform.runLater(new Runnable() {
            @Override
            public void run() {
                String tmp = toURL(url);

                if (tmp == null) {
                    tmp = toURL("http://" + url);
                }

                engine.load(tmp);
            }
        });
    }

    private static String toURL(String str) {
        try {
            return new URL(str).toExternalForm();
        } catch (MalformedURLException exception) {
            return null;
        }
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                MediaFeedsFacebookFinder browser = null;
                try {
                    browser = new MediaFeedsFacebookFinder();
                } catch (ClassNotFoundException ex) {
                    Logger.getLogger(MediaFeedsFacebookFinder.class.getName()).log(Level.SEVERE, null, ex);
                } catch (InstantiationException ex) {
                    Logger.getLogger(MediaFeedsFacebookFinder.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalAccessException ex) {
                    Logger.getLogger(MediaFeedsFacebookFinder.class.getName()).log(Level.SEVERE, null, ex);
                } catch (UnsupportedLookAndFeelException ex) {
                    Logger.getLogger(MediaFeedsFacebookFinder.class.getName()).log(Level.SEVERE, null, ex);
                }
                browser.setVisible(true);
                browser.loadURL("https://www.facebook.com/srch.php");
            }
        });
    }
}
